VERSION 2.00
Begin Form frmLongFileNames 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Long File Names VB 3.0"
   ClientHeight    =   3870
   ClientLeft      =   1170
   ClientTop       =   1605
   ClientWidth     =   7170
   Height          =   4275
   Left            =   1110
   LinkTopic       =   "Form1"
   ScaleHeight     =   3870
   ScaleWidth      =   7170
   Top             =   1260
   Width           =   7290
   Begin CommandButton cmdFileInfo 
      Caption         =   "&File Info"
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   405
      Left            =   4290
      TabIndex        =   9
      Top             =   3210
      Width           =   1230
   End
   Begin CommandButton cmdVolInfo 
      Caption         =   "&Vol Info"
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   405
      Left            =   3000
      TabIndex        =   8
      Top             =   3210
      Width           =   1230
   End
   Begin ListBox lstLongFileNames 
      Height          =   2565
      Left            =   2700
      Sorted          =   -1  'True
      TabIndex        =   6
      Top             =   390
      Visible         =   0   'False
      Width           =   4245
   End
   Begin CommandButton cmdQuit 
      Cancel          =   -1  'True
      Caption         =   "&Quit"
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   405
      Left            =   5730
      TabIndex        =   5
      Top             =   3210
      Width           =   1230
   End
   Begin CommandButton cmdLongNames 
      Caption         =   "&Long Names"
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   405
      Left            =   1530
      TabIndex        =   4
      Top             =   3210
      Width           =   1230
   End
   Begin CommandButton cmdShortNames 
      Caption         =   "&Short Names"
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   405
      Left            =   240
      TabIndex        =   3
      Top             =   3210
      Width           =   1230
   End
   Begin FileListBox filShortFileNames 
      Height          =   2565
      Hidden          =   -1  'True
      Left            =   2700
      System          =   -1  'True
      TabIndex        =   2
      Top             =   390
      Width           =   4245
   End
   Begin DirListBox dirList 
      Height          =   2055
      Left            =   240
      TabIndex        =   1
      Top             =   900
      Width           =   2175
   End
   Begin DriveListBox drvList 
      Height          =   315
      Left            =   240
      TabIndex        =   0
      Top             =   420
      Width           =   2175
   End
   Begin Label lblTypeNames 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Short Names:"
      Height          =   195
      Left            =   2700
      TabIndex        =   7
      Top             =   150
      Width           =   1155
   End
End
Option Explicit

Sub cmdFileInfo_Click ()

   ' -----------------------------------------------------
   ' If the listbox is visible, then we are looking at
   '   LONG filenames
   ' -----------------------------------------------------
   If gintIsShortNames = False Then
      If Me!lstLongFileNames.ListIndex = -1 Then
         MsgBox "No file selected!", vbExclamation, "Error"
      Else
         Load frmDatesTimes
         frmDatesTimes.Show vbModal
      End If
   
   
   ' -----------------------------------------------------
   ' Otherwise, we are looking at SHORT filenames
   ' -----------------------------------------------------
   Else
      If Me!filShortFileNames.ListIndex = -1 Then
         MsgBox "No file selected!", vbExclamation, "Error"
      Else
         Load frmDatesTimes
         frmDatesTimes.Show vbModal
      End If
   End If

End Sub

' --------------------------------------------------------
' Set the caption of list/directory list, set whether the
'   directory list or listbox is visible, and set global
'   variable indicating this
' --------------------------------------------------------
Sub cmdLongNames_Click ()
   
   Me!lblTypeNames.Caption = "Long Names:"
   Me!filShortFileNames.Visible = False
   Me!lstLongFileNames.Visible = True
   
   gintIsShortNames = False

   mprocSynchLists
End Sub

Sub cmdQuit_Click ()
   Unload Me
End Sub

' --------------------------------------------------------
' Set the caption of list/directory list, set whether the
'   directory list or listbox is visible, and set global
'   variable indicating this
' --------------------------------------------------------
Sub cmdShortNames_Click ()
   
   Me!lblTypeNames.Caption = "Short Names:"
   Me!filShortFileNames.Visible = True
   Me!lstLongFileNames.Visible = False
   
   gintIsShortNames = True

   mprocSynchLists
End Sub

Sub cmdVolInfo_Click ()
   Load frmVolInfo
   frmVolInfo.Show vbModal
End Sub

Sub dirList_Change ()
   Dim pstrFileSpec        As String
   Dim pstrDirPath         As String
   Dim pintMaxChars        As Integer
   Dim pintNumFiles        As Integer
   Dim pintRtn             As Integer
   Dim pintLoop            As Integer
   Dim pdblAveCharWidth    As Double   ' Average width of characters
   Dim paTabs()            As Integer  ' Array of tabs for listbox
   Dim paFileNames()       As String
   
   
   ' -----------------------------------------------------
   ' Get average width of lowercase characters
   ' -----------------------------------------------------
   pdblAveCharWidth = (Me.TextWidth("abcdefghijklmnopqrstuvwxyz") / Screen.TwipsPerPixelX) / 26
   
   
   ' -----------------------------------------------------
   ' Set the cursor to an hourglass
   ' -----------------------------------------------------
   Me.MousePointer = vbHourGlass

   
   ' -----------------------------------------------------
   ' Set filespec to all files
   ' Set the path to the path of directory list box, and
   '   change to that directory
   ' -----------------------------------------------------
   pstrFileSpec = "*.*"
   Me!filShortFileNames.Path = Me!dirList.Path
   ChDrive Left$(Me!dirList.Path, 1)
   ChDir Me!dirList.Path

   
   ' -----------------------------------------------------
   ' Set the path to pass to the directory -- yes, it
   '   needs a trailing backslash in the function
   ' -----------------------------------------------------
   pstrDirPath = Me!dirList.Path
   If Right$(pstrDirPath, 1) <> "\" Then
      pstrDirPath = pstrDirPath & "\"
   End If

   
   ' -----------------------------------------------------
   ' Get the long and short names to populate the listbox,
   '   whether or not it is visible right now
   ' -----------------------------------------------------
   gprocGetLongFilename pstrDirPath, pstrFileSpec, pintMaxChars, paFileNames(), pintNumFiles
   
   
   ' -----------------------------------------------------
   ' First clear all the tabs in the listbox, then set
   '   the tabs as needed
   ' -----------------------------------------------------
   Me!lstLongFileNames.Clear
   ReDim paTabs(1 To 1)
   paTabs(1) = 70
   pintRtn = SendMessage(Me!lstLongFileNames.hWnd, LB_SETTABSTOPS, 0, ByVal 0&)
   pintRtn = SendMessage(Me!lstLongFileNames.hWnd, LB_SETTABSTOPS, 1, paTabs(1))
   
   
   ' -----------------------------------------------------
   ' Add the filenames to the listbox with .Sorted = True
   ' -----------------------------------------------------
   If pintNumFiles > 0 Then
      For pintLoop = 1 To pintNumFiles
         Me!lstLongFileNames.AddItem paFileNames(pintLoop)
      Next pintLoop
   End If

   
   ' -----------------------------------------------------
   ' Set the ItemData to "sorted" order
   ' -----------------------------------------------------
   If pintNumFiles > 0 Then
      For pintLoop = 0 To pintNumFiles - 1
         Me!lstLongFileNames.ItemData(pintLoop) = pintLoop
      Next pintLoop
   End If

   
   ' -----------------------------------------------------
   ' Set a horizontal scrollbar if needed
   ' Tell the list box to refresh its display.
   ' -----------------------------------------------------
   pintRtn = SendMessage(Me!lstLongFileNames.hWnd, LB_SETHORIZONTALEXTENT, (CDbl(pintMaxChars + 10) * pdblAveCharWidth), 0&)
   Me!lstLongFileNames.Refresh

   
   ' -----------------------------------------------------
   ' Set the cursor back to normal
   ' -----------------------------------------------------
   Me.MousePointer = vbDefault

End Sub

Sub drvList_Change ()
   Me!dirList.Path = Me!drvList.Drive
   ChDrive Me!drvList.Drive
End Sub

Sub Form_Load ()
   
   ' *****************************************************
   ' *****************************************************
   ' ***    DELETE FOLLOWING LINE if you are using     ***
   ' ***                 VB 4# / 16                    ***
   ' *****************************************************
   ' *****************************************************
   vbNullChar = Chr$(0)
   
   
   ' -----------------------------------------------------
   ' Start with the file list box (short names only)
   ' -----------------------------------------------------
   gintIsShortNames = True
   Me!lblTypeNames.Caption = "Short Names:"

   
   ' -----------------------------------------------------
   ' Initialize the Call32 calls (do only once)
   ' -----------------------------------------------------
   gprocInitRegistryCalls
   
   
   ' -----------------------------------------------------
   ' Update the listbox (although it isn't visible yet)
   ' -----------------------------------------------------
   dirList_Change
   
End Sub

Sub mprocSynchLists ()
   Dim pintIndex  As Integer
   Dim pintLoop   As Integer


   On Error Resume Next
   If gintIsShortNames = True Then
      pintIndex = Me!lstLongFileNames.ItemData(Me!lstLongFileNames.ListIndex)
      Me!filShortFileNames.ListIndex = pintIndex
      Me!filShortFileNames.TopIndex = pintIndex
   Else
      pintIndex = Me!filShortFileNames.ListIndex
      For pintLoop = 0 To Me!lstLongFileNames.ListCount - 1
         If Me!lstLongFileNames.ItemData(pintLoop) = pintIndex Then
            Me!lstLongFileNames.ListIndex = pintLoop
            Me!lstLongFileNames.TopIndex = pintLoop
            Exit For
         End If
      Next pintLoop
   End If
   On Error GoTo 0

End Sub

